/******************************************************************************/
/*                                                                            */
/*  <<< Copyright >>>                                                         */
/*                                                                            */
/*  The "xmemo" software is copyright 1999 by Takao Abe.                      */
/*  All rights reserved.                                                      */
/*                                                                            */
/*  The "xmemo" software refers to the source code, the binary code,          */
/*  the documents, and all derivatives based on this software under           */
/*  the copyright law, that is a software containing a program or a           */
/*  portion of a program, regardless of modifications and/or translations.    */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/*  <<< Licence and redistribution >>>                                        */
/*                                                                            */
/*  The source code and the binary code are free software.                    */
/*  The use and redistribution of source code and binary code are permitted   */
/*  provided that the following conditions are met:                           */
/*  You may use the software for private use and commercial use,              */
/*  and may modify your copy or copies of the software or any portion of it.  */
/*                                                                            */
/*  THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESSED OR IMPLIED            */
/*  WARRANTIES OF ANY KIND, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED        */
/*  WARRANTIES OF MERCHANTABLILITY AND FITNESS FOR A PARTICULAR PURPOSE.      */
/*  IN NO EVENT SHALL THE AUTHOR TAKAO ABE BE LIABLE FOR ANY DIRECT,          */
/*  INDIRECT, GENERAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES           */
/*  ( INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR       */
/*  SERVICES; LOSS OF USE, DATA OR PROFITS; OR BUSINESS INTERRUPTION )        */
/*  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,       */
/*  STRICT LIABILITY, OR TORT ( INCLUDING NEGLIGENCE OR OTHERWISE )           */
/*  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED       */
/*  OF THE POSSIBILITY OF SUCH DAMAGE.                                        */
/*                                                                            */
/*  Redistribution and use in source form or binary form, with or without     */
/*  modification, the whole program or a portion of it, are permitted         */
/*  provided that one retains the entire copyright notice properly, and       */
/*  displays or retains this license in the documentation and/or other        */
/*  materials provided with the distribution.                                 */
/*                                                                            */
/*  Redistribution and use in source form or binary form, with modification,  */
/*  the whole program or a portion of it, are permitted provided that one     */
/*  declares that it is modified software and not original, and displays or   */
/*  describes any modifications in the documentation and/or other materials   */
/*  provided with the distribution.                                           */
/*                                                                            */
/*  This software and the name of the author must not be used to endorse or   */
/*  promote products derived from this software without prior written         */
/*  permission.                                                               */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/*  EMail   abetakao@bea.hi-ho.ne.jp                                          */
/*          HCA00763@nifty.ne.jp                                              */
/*                                                                            */
/*  URL     http://www.bea.hi-ho.ne.jp/abetakao/                              */
/*                                                                            */
/******************************************************************************/


#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<time.h>


#include	<X11/Intrinsic.h>
#include	<X11/StringDefs.h>
#include	<X11/Shell.h>

#include	<X11/Xaw/Command.h>
#include	<X11/Xaw/Form.h>
#include	<X11/Xaw/Label.h>


#include	"xmemo.h"
#include	"xmemodata.h"
#include	"xmemofunc.h"


/******************************************************************************/
/*  Local variables                                                           */
/******************************************************************************/


static	Widget	wDlgHelpAboutxmemo ;
static	Widget	wDlgHelpAboutForm ;
static	Widget	wDlgHelpAboutLblVersion ;
static	Widget	wDlgHelpAboutLblCopyright ;
static	Widget	wDlgHelpAboutLblEMail [ 2 ] ;
static	Widget	wDlgHelpAboutLblURL ;


/******************************************************************************/
/*  AboutxmemoOK_Click                                                        */
/******************************************************************************/

static void AboutxmemoOK_Click ( Widget w, caddr_t pClientData, caddr_t pCallData )
{

	if ( bMemoTraceLog ) xmemo_TraceLog ( "AboutxmemoOK_Click", NULL ) ;

	XtPopdown ( wDlgHelpAboutxmemo ) ;

}

static XtCallbackRec pAboutxmemoOK_CallbackRec [ ] =
{
	{ (XtCallbackProc) AboutxmemoOK_Click, NULL },
	{ NULL, NULL }
} ;

/******************************************************************************/
/*  xmemo_InitDialog_Aboutxmemo                                               */
/******************************************************************************/

int xmemo_InitDialog_Aboutxmemo ( )
{

static	char	sEMail     [ ] = "EMail : abetakao@bea.hi-ho.ne.jp" ;
static	char	sEMail2    [ ] = "        HCA00763@nifty.ne.jp" ;
static	char	sURL       [ ] = "URL   : http://www.bea.hi-ho.ne.jp/abetakao/" ;

int 	n ;
Arg 	xArg [ 10 ] ;

	if ( bMemoTraceLog ) xmemo_TraceLog ( "xmemo_InitDialog_Aboutxmemo", NULL ) ;

	n = 0 ;
	XtSetArg ( xArg[n], XtNtitle , "xmemo - About \"xmemo\"" ) ; n ++ ;
	XtSetArg ( xArg[n], XtNwidth , 500 ) ; n ++ ;
	XtSetArg ( xArg[n], XtNheight, 250 ) ; n ++ ;
	wDlgHelpAboutxmemo = XtCreatePopupShell ( "DlgAboutxmemo", transientShellWidgetClass, wTop, xArg, n ) ;
	                                  
	/* Main form */

	wDlgHelpAboutForm = XtCreateManagedWidget ( "Form", formWidgetClass, wDlgHelpAboutxmemo, NULL, 0 ) ;

	n = 0 ;
	XtSetArg ( xArg[n], XtNlabel      , pVersion      ) ; n ++ ;
	XtSetArg ( xArg[n], XtNjustify    , XtJustifyLeft ) ; n ++ ;
	XtSetArg ( xArg[n], XtNborderWidth, 0             ) ; n ++ ;
	XtSetArg ( xArg[n], XtNtop        , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNbottom     , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNleft       , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNright      , XtChainLeft   ) ; n ++ ;
	wDlgHelpAboutLblVersion = XtCreateManagedWidget ( "Label", labelWidgetClass, wDlgHelpAboutForm, xArg, n ) ;

	n = 0 ;
	XtSetArg ( xArg[n], XtNlabel      , pCopyright    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNjustify    , XtJustifyLeft ) ; n ++ ;
	XtSetArg ( xArg[n], XtNborderWidth, 0             ) ; n ++ ;
	XtSetArg ( xArg[n], XtNtop        , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNbottom     , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNleft       , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNright      , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromVert   , wDlgHelpAboutLblVersion ) ; n ++ ;
	wDlgHelpAboutLblCopyright = XtCreateManagedWidget ( "Label", labelWidgetClass, wDlgHelpAboutForm, xArg, n ) ;

	n = 0 ;
	XtSetArg ( xArg[n], XtNlabel      , sEMail        ) ; n ++ ;
	XtSetArg ( xArg[n], XtNjustify    , XtJustifyLeft ) ; n ++ ;
	XtSetArg ( xArg[n], XtNborderWidth, 0             ) ; n ++ ;
	XtSetArg ( xArg[n], XtNtop        , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNbottom     , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNleft       , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNright      , XtChainLeft  ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromVert   , wDlgHelpAboutLblCopyright ) ; n ++ ;
	XtSetArg ( xArg[n], XtNvertDistance , 30 ) ; n ++ ;
	XtSetArg ( xArg[n], XtNhorizDistance, 30 ) ; n ++ ;
	wDlgHelpAboutLblEMail[0] = XtCreateManagedWidget ( "Label", labelWidgetClass, wDlgHelpAboutForm, xArg, n ) ;

	n = 0 ;
	XtSetArg ( xArg[n], XtNlabel      , sEMail2       ) ; n ++ ;
	XtSetArg ( xArg[n], XtNjustify    , XtJustifyLeft ) ; n ++ ;
	XtSetArg ( xArg[n], XtNborderWidth, 0             ) ; n ++ ;
	XtSetArg ( xArg[n], XtNtop        , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNbottom     , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNleft       , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNright      , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromVert   , wDlgHelpAboutLblEMail[0] ) ; n ++ ;
	XtSetArg ( xArg[n], XtNhorizDistance, 30 ) ; n ++ ;
	wDlgHelpAboutLblEMail[1] = XtCreateManagedWidget ( "Label", labelWidgetClass, wDlgHelpAboutForm, xArg, n ) ;

	n = 0 ;
	XtSetArg ( xArg[n], XtNlabel      , sURL          ) ; n ++ ;
	XtSetArg ( xArg[n], XtNjustify    , XtJustifyLeft ) ; n ++ ;
	XtSetArg ( xArg[n], XtNborderWidth, 0             ) ; n ++ ;
	XtSetArg ( xArg[n], XtNtop        , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNbottom     , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNleft       , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNright      , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromVert   , wDlgHelpAboutLblEMail[1] ) ; n ++ ;
	XtSetArg ( xArg[n], XtNhorizDistance, 30 ) ; n ++ ;
	wDlgHelpAboutLblURL = XtCreateManagedWidget ( "Label", labelWidgetClass, wDlgHelpAboutForm, xArg, n ) ;

	/* OK button */

	n = 0 ;
	XtSetArg ( xArg[n], XtNlabel    , "OK" ) ; n ++ ;
	XtSetArg ( xArg[n], XtNtop      , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNbottom   , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNleft     , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNright    , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromVert , wDlgHelpAboutLblURL ) ; n ++ ;
	XtSetArg ( xArg[n], XtNvertDistance , 30 ) ; n ++ ;
	XtSetArg ( xArg[n], XtNcallback, pAboutxmemoOK_CallbackRec ) ; n ++ ;
	XtCreateManagedWidget ( "CmdButton", commandWidgetClass, wDlgHelpAboutForm, xArg, n ) ;

}

/******************************************************************************/
/*  xmemo_PopupDialog_Aboutxmemo                                              */
/******************************************************************************/

int xmemo_PopupDialog_Aboutxmemo ( )
{

int 	x, y ;
int 	n ;
Arg	xArg [ 5 ] ;

	if ( bMemoTraceLog ) xmemo_TraceLog ( "xmemo_PopupDialog_Aboutxmemo", NULL ) ;

#if 0
	x = XDisplayWidth  ( XtDisplay(wTop), 0 ) - 200 ;
	y = XDisplayHeight ( XtDisplay(wTop), 0 ) - 100 ;

	n = 0 ;
	XtSetArg ( xArg[n], XtNx     , x   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNy     , y   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNwidth , 500 ) ; n ++ ;
	XtSetArg ( xArg[n], XtNheight, 250 ) ; n ++ ;
	XtSetValues ( wDlgHelpAboutxmemo, xArg, n ) ;
#endif

	XtPopup ( wDlgHelpAboutxmemo, XtGrabExclusive ) ;

	return RC_SUCCESS ;
	
}

/******************************************************************************/
/*  xmemo_PopdownDialog_Aboutxmemo                                            */
/******************************************************************************/

int xmemo_PopdownDialog_Aboutxmemo ( )
{

	if ( bMemoTraceLog ) xmemo_TraceLog ( "xmemo_PopdownDialog_Aboutxmemo", NULL ) ;

	XtPopdown ( wDlgHelpAboutxmemo ) ;

	return RC_SUCCESS ;

}
