/******************************************************************************/
/*                                                                            */
/*  <<< Copyright >>>                                                         */
/*                                                                            */
/*  The "xmemo" software is copyright 1999 by Takao Abe.                      */
/*  All rights reserved.                                                      */
/*                                                                            */
/*  The "xmemo" software refers to the source code, the binary code,          */
/*  the documents, and all derivatives based on this software under           */
/*  the copyright law, that is a software containing a program or a           */
/*  portion of a program, regardless of modifications and/or translations.    */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/*  <<< Licence and redistribution >>>                                        */
/*                                                                            */
/*  The source code and the binary code are free software.                    */
/*  The use and redistribution of source code and binary code are permitted   */
/*  provided that the following conditions are met:                           */
/*  You may use the software for private use and commercial use,              */
/*  and may modify your copy or copies of the software or any portion of it.  */
/*                                                                            */
/*  THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESSED OR IMPLIED            */
/*  WARRANTIES OF ANY KIND, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED        */
/*  WARRANTIES OF MERCHANTABLILITY AND FITNESS FOR A PARTICULAR PURPOSE.      */
/*  IN NO EVENT SHALL THE AUTHOR TAKAO ABE BE LIABLE FOR ANY DIRECT,          */
/*  INDIRECT, GENERAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES           */
/*  ( INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR       */
/*  SERVICES; LOSS OF USE, DATA OR PROFITS; OR BUSINESS INTERRUPTION )        */
/*  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,       */
/*  STRICT LIABILITY, OR TORT ( INCLUDING NEGLIGENCE OR OTHERWISE )           */
/*  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED       */
/*  OF THE POSSIBILITY OF SUCH DAMAGE.                                        */
/*                                                                            */
/*  Redistribution and use in source form or binary form, with or without     */
/*  modification, the whole program or a portion of it, are permitted         */
/*  provided that one retains the entire copyright notice properly, and       */
/*  displays or retains this license in the documentation and/or other        */
/*  materials provided with the distribution.                                 */
/*                                                                            */
/*  Redistribution and use in source form or binary form, with modification,  */
/*  the whole program or a portion of it, are permitted provided that one     */
/*  declares that it is modified software and not original, and displays or   */
/*  describes any modifications in the documentation and/or other materials   */
/*  provided with the distribution.                                           */
/*                                                                            */
/*  This software and the name of the author must not be used to endorse or   */
/*  promote products derived from this software without prior written         */
/*  permission.                                                               */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/*  EMail   abetakao@bea.hi-ho.ne.jp                                          */
/*          HCA00763@nifty.ne.jp                                              */
/*                                                                            */
/*  URL     http://www.bea.hi-ho.ne.jp/abetakao/                              */
/*                                                                            */
/******************************************************************************/


#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<time.h>


#include	<X11/Intrinsic.h>
#include	<X11/StringDefs.h>
#include	<X11/Shell.h>

#include	<X11/Xaw/AsciiText.h>
#include	<X11/Xaw/Command.h>
#include	<X11/Xaw/Form.h>
#include	<X11/Xaw/Label.h>
#include	<X11/Xaw/Toggle.h>


#include	"xmemo.h"
#include	"xmemodata.h"
#include	"xmemofunc.h"


/******************************************************************************/
/*  Local variables                                                           */
/******************************************************************************/


static	Widget	wDlgOptionLog ;
static	Widget	wDlgOptionLogForm ;
static	Widget	wDlgOptionLogEdit ;
static	Widget	wDlgOptionLogLbl [ 2 ] ;
static	Widget	wDlgOptionLogTglLog [ 3 ] ;
static	Widget	wDlgOptionLogTxtKeep ;
static	Widget	wDlgOptionLogCmdClose ;
static	Widget	wDlgOptionLogCmdCancel ;


/******************************************************************************/
/*  OptionLogClose_Click                                                      */
/******************************************************************************/

static void OptionLogClose_Click ( Widget w, caddr_t pClientData, caddr_t pCallData )
{

int 	n ;
Arg 	xArg [ 5 ] ;
char	*pKeep ;
int 	bState ;

	if ( bMemoTraceLog ) xmemo_TraceLog ( "OptionLogClose_Click", NULL ) ;

	/* Input */

	n = 0 ;
	XtSetArg ( xArg[n], XtNstring, &pKeep ) ; n ++ ;
	XtGetValues ( wDlgOptionLogTxtKeep, xArg, n ) ;

	/* Check */

	if ( ! xmemo_CheckNumeric ( pKeep ) ) {
		XBell ( XtDisplay(wTop), 100 ) ;
		return ;
	}

	xmemo_PopdownDialog_OptionLog ( ) ;

	/* Save */

	n = 0 ;
	XtSetArg ( xArg[n], XtNstate, &bState ) ; n ++ ;
	XtGetValues ( wDlgOptionLogTglLog[0], xArg, n ) ;

	bMemoLogSend = ( ( bState & True ) == True ) ;

	n = 0 ;
	XtSetArg ( xArg[n], XtNstate, &bState ) ; n ++ ;
	XtGetValues ( wDlgOptionLogTglLog[1], xArg, n ) ;

	bMemoLogReceive = ( ( bState & True ) == True ) ;

	n = 0 ;
	XtSetArg ( xArg[n], XtNstate, &bState ) ; n ++ ;
	XtGetValues ( wDlgOptionLogTglLog[2], xArg, n ) ;

	bMemoLogDelete = ( ( bState & True ) == True ) ;

	if ( pKeep != NULL ) iMemoLogKeep = atoi ( pKeep ) ;

	/* Save */

	xmemo_SaveOptionLog ( ) ;

}

static XtCallbackRec pOptionLogClose_CallbackRec [ ] =
{
	{ (XtCallbackProc) OptionLogClose_Click, NULL },
	{ NULL, NULL }
} ;

/******************************************************************************/
/*  OptionLogCancel_Click                                                     */
/******************************************************************************/

static void OptionLogCancel_Click ( Widget w, caddr_t pClientData, caddr_t pCallData )
{

zChainType	*pChain ;
zNetworkType	*pNetwork ;

	if ( bMemoTraceLog ) xmemo_TraceLog ( "OptionLogCancel_Click", NULL ) ;

	xmemo_PopdownDialog_OptionLog ( ) ;

}

static XtCallbackRec pOptionLogCancel_CallbackRec [ ] =
{
	{ (XtCallbackProc) OptionLogCancel_Click, NULL },
	{ NULL, NULL }
} ;

/******************************************************************************/
/*  xmemo_InitDialog_OptionLog                                                */
/******************************************************************************/

int xmemo_InitDialog_OptionLog ( )
{

int 	n ;
Arg 	xArg [ 16 ] ;

	if ( bMemoTraceLog ) xmemo_TraceLog ( "xmemo_InitDialog_OptionLog", NULL ) ;

	/* Dialog shell */

	n = 0 ;
	XtSetArg ( xArg[n], XtNtitle , "xmemo - Option [ Log ]" ) ; n ++ ;
	XtSetArg ( xArg[n], XtNwidth , 400 ) ; n ++ ;
	XtSetArg ( xArg[n], XtNheight, 200 ) ; n ++ ;
	wDlgOptionLog = XtCreatePopupShell ( "DlgOptLog", transientShellWidgetClass, wTop, xArg, n ) ;
	                                  
	/* Main form */

	wDlgOptionLogForm = XtCreateManagedWidget ( "Form", formWidgetClass, wDlgOptionLog, xArg, 0 ) ;

	/* Edit area */

	n = 0 ;
	XtSetArg ( xArg[n], XtNtop   , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNbottom, XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNleft  , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNright , XtChainRight  ) ; n ++ ;
	wDlgOptionLogEdit = XtCreateManagedWidget ( "Body", formWidgetClass, wDlgOptionLogForm, xArg, n ) ;

	n = 0 ;
	XtSetArg ( xArg[n], XtNwidth   , 100 ) ; n ++ ;
	XtSetArg ( xArg[n], XtNlabel   , "Logs" ) ; n ++ ;
	XtSetArg ( xArg[n], XtNjustify , XtJustifyLeft ) ; n ++ ;
	XtSetArg ( xArg[n], XtNborderWidth, 0 ) ; n ++ ;	
	XtSetArg ( xArg[n], XtNtop   , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNleft  , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNright , XtChainLeft   ) ; n ++ ;
	wDlgOptionLogLbl[0] = XtCreateManagedWidget ( "Label", labelWidgetClass, wDlgOptionLogEdit, xArg, n ) ;

	n = 0 ;
	XtSetArg ( xArg[n], XtNwidth    , 80 ) ; n ++ ;
	XtSetArg ( xArg[n], XtNlabel    , "Send" ) ; n ++ ;
	XtSetArg ( xArg[n], XtNtop      , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNleft     , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNright    , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromVert , NULL ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromHoriz, wDlgOptionLogLbl[0] ) ; n ++ ;	
	wDlgOptionLogTglLog[0] = XtCreateManagedWidget ( "TglButton", toggleWidgetClass, wDlgOptionLogEdit, xArg, n ) ;

	n = 0 ;
	XtSetArg ( xArg[n], XtNwidth    , 80 ) ; n ++ ;
	XtSetArg ( xArg[n], XtNlabel    , "Receive" ) ; n ++ ;
	XtSetArg ( xArg[n], XtNtop      , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNleft     , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNright    , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromVert , NULL ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromHoriz, wDlgOptionLogTglLog[0] ) ; n ++ ;	
	wDlgOptionLogTglLog[1] = XtCreateManagedWidget ( "TglButton", toggleWidgetClass, wDlgOptionLogEdit, xArg, n ) ;

	n = 0 ;
	XtSetArg ( xArg[n], XtNwidth    , 80 ) ; n ++ ;
	XtSetArg ( xArg[n], XtNlabel    , "Delete" ) ; n ++ ;
	XtSetArg ( xArg[n], XtNtop      , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNleft     , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNright    , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromVert , NULL ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromHoriz, wDlgOptionLogTglLog[1] ) ; n ++ ;	
	wDlgOptionLogTglLog[2] = XtCreateManagedWidget ( "TglButton", toggleWidgetClass, wDlgOptionLogEdit, xArg, n ) ;

	n = 0 ;
	XtSetArg ( xArg[n], XtNwidth   , 100 ) ; n ++ ;
	XtSetArg ( xArg[n], XtNlabel   , "Keep" ) ; n ++ ;
	XtSetArg ( xArg[n], XtNjustify , XtJustifyLeft ) ; n ++ ;
	XtSetArg ( xArg[n], XtNborderWidth, 0 ) ; n ++ ;	
	XtSetArg ( xArg[n], XtNtop   , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNleft  , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNright , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromVert, wDlgOptionLogLbl[0] ) ; n ++ ;
	wDlgOptionLogLbl[1] = XtCreateManagedWidget ( "Label", labelWidgetClass, wDlgOptionLogEdit, xArg, n ) ;

	n = 0 ;
	XtSetArg ( xArg[n], XtNwidth    , 50 ) ; n ++ ;
	XtSetArg ( xArg[n], XtNtop      , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNleft     , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNright    , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromVert , wDlgOptionLogTglLog[0] ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromHoriz, wDlgOptionLogLbl[1] ) ; n ++ ;	
	XtSetArg ( xArg[n], XtNeditType , XawtextEdit   ) ; n ++ ;	
	wDlgOptionLogTxtKeep = XtCreateManagedWidget ( "Text", asciiTextWidgetClass, wDlgOptionLogEdit, xArg, n ) ;

	/* Command button ( Bottom ) */

	n = 0 ;
	XtSetArg ( xArg[n], XtNlabel    , "OK" ) ; n ++ ;
	XtSetArg ( xArg[n], XtNtop      , XtChainBottom ) ; n ++ ;
	XtSetArg ( xArg[n], XtNbottom   , XtChainBottom ) ; n ++ ;
	XtSetArg ( xArg[n], XtNleft     , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNright    , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromVert , wDlgOptionLogEdit ) ; n ++ ;
	XtSetArg ( xArg[n], XtNcallback , pOptionLogClose_CallbackRec ) ; n ++ ;
	wDlgOptionLogCmdClose = XtCreateManagedWidget ( "CmdButton", commandWidgetClass, wDlgOptionLogForm, xArg, n ) ;

	n = 0 ;
	XtSetArg ( xArg[n], XtNlabel    , "Cancel" ) ; n ++ ;
	XtSetArg ( xArg[n], XtNtop      , XtChainBottom ) ; n ++ ;
	XtSetArg ( xArg[n], XtNbottom   , XtChainBottom ) ; n ++ ;
	XtSetArg ( xArg[n], XtNleft     , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNright    , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromVert , wDlgOptionLogEdit ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromHoriz, wDlgOptionLogCmdClose ) ; n ++ ;
	XtSetArg ( xArg[n], XtNcallback , pOptionLogCancel_CallbackRec ) ; n ++ ;
	wDlgOptionLogCmdCancel = XtCreateManagedWidget ( "CmdButton", commandWidgetClass, wDlgOptionLogForm, xArg, n ) ;

	return RC_SUCCESS ;

}

/******************************************************************************/
/*  xmemo_PopupDialog_OptionLog                                               */
/******************************************************************************/

int xmemo_PopupDialog_OptionLog ( )
{

int 	n ;
Arg 	xArg [ 5 ] ;
char	sBuf [ 20 ] ;

	if ( bMemoTraceLog ) xmemo_TraceLog ( "xmemo_PopupDialog_OptionLog", NULL ) ;

	n = 0 ;
	if ( bMemoLogSend ) XtSetArg ( xArg[n], XtNstate, True  ) ;
	else                XtSetArg ( xArg[n], XtNstate, False ) ;
	n ++ ;
	XtSetValues ( wDlgOptionLogTglLog[0], xArg, n ) ;

	n = 0 ;
	if ( bMemoLogReceive ) XtSetArg ( xArg[n], XtNstate, True  ) ;
	else                   XtSetArg ( xArg[n], XtNstate, False ) ;
	n ++ ;
	XtSetValues ( wDlgOptionLogTglLog[1], xArg, n ) ;

	n = 0 ;
	if ( bMemoLogDelete ) XtSetArg ( xArg[n], XtNstate, True  ) ;
	else                  XtSetArg ( xArg[n], XtNstate, False ) ;
	n ++ ;
	XtSetValues ( wDlgOptionLogTglLog[2], xArg, n ) ;

	n = 0 ;
	sprintf ( sBuf, "%d", iMemoLogKeep ) ;
	XtSetArg ( xArg[n], XtNstring, sBuf ) ; n ++ ;
	XtSetValues ( wDlgOptionLogTxtKeep, xArg, n ) ;

	XtPopup ( wDlgOptionLog, XtGrabExclusive ) ;

	return RC_SUCCESS ;
	
}

/******************************************************************************/
/*  xmemo_PopdownDialog_OptionLog                                             */
/******************************************************************************/

int xmemo_PopdownDialog_OptionLog ( )
{

	if ( bMemoTraceLog ) xmemo_TraceLog ( "xmemo_PopdownDialog_OptionLog", NULL ) ;

	XtPopdown ( wDlgOptionLog ) ;

	return RC_SUCCESS ;

}
