/******************************************************************************/
/*                                                                            */
/*  <<< Copyright >>>                                                         */
/*                                                                            */
/*  The "xmemo" software is copyright 1999 by Takao Abe.                      */
/*  All rights reserved.                                                      */
/*                                                                            */
/*  The "xmemo" software refers to the source code, the binary code,          */
/*  the documents, and all derivatives based on this software under           */
/*  the copyright law, that is a software containing a program or a           */
/*  portion of a program, regardless of modifications and/or translations.    */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/*  <<< Licence and redistribution >>>                                        */
/*                                                                            */
/*  The source code and the binary code are free software.                    */
/*  The use and redistribution of source code and binary code are permitted   */
/*  provided that the following conditions are met:                           */
/*  You may use the software for private use and commercial use,              */
/*  and may modify your copy or copies of the software or any portion of it.  */
/*                                                                            */
/*  THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESSED OR IMPLIED            */
/*  WARRANTIES OF ANY KIND, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED        */
/*  WARRANTIES OF MERCHANTABLILITY AND FITNESS FOR A PARTICULAR PURPOSE.      */
/*  IN NO EVENT SHALL THE AUTHOR TAKAO ABE BE LIABLE FOR ANY DIRECT,          */
/*  INDIRECT, GENERAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES           */
/*  ( INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR       */
/*  SERVICES; LOSS OF USE, DATA OR PROFITS; OR BUSINESS INTERRUPTION )        */
/*  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,       */
/*  STRICT LIABILITY, OR TORT ( INCLUDING NEGLIGENCE OR OTHERWISE )           */
/*  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED       */
/*  OF THE POSSIBILITY OF SUCH DAMAGE.                                        */
/*                                                                            */
/*  Redistribution and use in source form or binary form, with or without     */
/*  modification, the whole program or a portion of it, are permitted         */
/*  provided that one retains the entire copyright notice properly, and       */
/*  displays or retains this license in the documentation and/or other        */
/*  materials provided with the distribution.                                 */
/*                                                                            */
/*  Redistribution and use in source form or binary form, with modification,  */
/*  the whole program or a portion of it, are permitted provided that one     */
/*  declares that it is modified software and not original, and displays or   */
/*  describes any modifications in the documentation and/or other materials   */
/*  provided with the distribution.                                           */
/*                                                                            */
/*  This software and the name of the author must not be used to endorse or   */
/*  promote products derived from this software without prior written         */
/*  permission.                                                               */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/*  EMail   abetakao@bea.hi-ho.ne.jp                                          */
/*          HCA00763@nifty.ne.jp                                              */
/*                                                                            */
/*  URL     http://www.bea.hi-ho.ne.jp/abetakao/                              */
/*                                                                            */
/******************************************************************************/


#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<time.h>
#include	<sys/types.h>
#include	<sys/stat.h>
#include	<dirent.h>


#include	<X11/Intrinsic.h>


#include	"xmemo.h"
#include	"xmemodata.h"
#include	"xmemofunc.h"


/******************************************************************************/
/*  xmemo_CreateDirectory                                                     */
/******************************************************************************/

int xmemo_CreateDirectory (  )
{

int 	rc ;
char	sDir [ MAXLEN_FILENAME ] ;
DIR 	*pDir ;

	if ( bMemoTraceLog ) xmemo_TraceLog ( "xmemo_CreateDirectory", NULL ) ;

	pDir = opendir ( sMemoBaseDir ) ;
	if ( pDir != NULL ) {
		closedir ( pDir ) ;
	} else {
		rc = mkdir ( sMemoBaseDir, 0700 ) ;
		if ( rc != 0 ) {
			xmemo_ErrorLog ( "xmemo_CreateDirectory", "mkdir", sMemoBaseDir ) ;
			return RC_ERROR ;
		}
	}

	strcpy ( sDir, sMemoBaseDir ) ;
	strcat ( sDir, "/" ) ;
	strcat ( sDir, sMemoConfDir ) ;
	pDir = opendir ( sDir ) ;
	if ( pDir != NULL ) {
		closedir ( pDir ) ;
	} else {
		rc = mkdir ( sDir, 0700 ) ;
		if ( rc != 0 ) {
			xmemo_ErrorLog ( "xmemo_CreateDirectory", "mkdir", sDir ) ;
			return RC_ERROR ;
		}
	}

	strcpy ( sDir, sMemoBaseDir ) ;
	strcat ( sDir, "/" ) ;
	strcat ( sDir, sMemoDataDir ) ;
	pDir = opendir ( sDir ) ;
	if ( pDir != NULL ) {
		closedir ( pDir ) ;
	} else {
		rc = mkdir ( sDir, 0700 ) ;
		if ( rc != 0 ) {
			xmemo_ErrorLog ( "xmemo_CreateDirectory", "mkdir", sDir ) ;
			return RC_ERROR ;
		}
	}

	strcpy ( sDir, sMemoBaseDir ) ;
	strcat ( sDir, "/" ) ;
	strcat ( sDir, sMemoLogDir ) ;
	pDir = opendir ( sDir ) ;
	if ( pDir != NULL ) {
		closedir ( pDir ) ;
	} else {
		rc = mkdir ( sDir, 0700 ) ;
		if ( rc != 0 ) {
			xmemo_ErrorLog ( "xmemo_CreateDirectory", "mkdir", sDir ) ;
			return RC_ERROR ;
		}
	}

	return RC_SUCCESS ;

}
