/******************************************************************************/
/*                                                                            */
/*  <<< Copyright >>>                                                         */
/*                                                                            */
/*  The "xmemo" software is copyright 1999 by Takao Abe.                      */
/*  All rights reserved.                                                      */
/*                                                                            */
/*  The "xmemo" software refers to the source code, the binary code,          */
/*  the documents, and all derivatives based on this software under           */
/*  the copyright law, that is a software containing a program or a           */
/*  portion of a program, regardless of modifications and/or translations.    */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/*  <<< Licence and redistribution >>>                                        */
/*                                                                            */
/*  The source code and the binary code are free software.                    */
/*  The use and redistribution of source code and binary code are permitted   */
/*  provided that the following conditions are met:                           */
/*  You may use the software for private use and commercial use,              */
/*  and may modify your copy or copies of the software or any portion of it.  */
/*                                                                            */
/*  THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESSED OR IMPLIED            */
/*  WARRANTIES OF ANY KIND, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED        */
/*  WARRANTIES OF MERCHANTABLILITY AND FITNESS FOR A PARTICULAR PURPOSE.      */
/*  IN NO EVENT SHALL THE AUTHOR TAKAO ABE BE LIABLE FOR ANY DIRECT,          */
/*  INDIRECT, GENERAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES           */
/*  ( INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR       */
/*  SERVICES; LOSS OF USE, DATA OR PROFITS; OR BUSINESS INTERRUPTION )        */
/*  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,       */
/*  STRICT LIABILITY, OR TORT ( INCLUDING NEGLIGENCE OR OTHERWISE )           */
/*  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED       */
/*  OF THE POSSIBILITY OF SUCH DAMAGE.                                        */
/*                                                                            */
/*  Redistribution and use in source form or binary form, with or without     */
/*  modification, the whole program or a portion of it, are permitted         */
/*  provided that one retains the entire copyright notice properly, and       */
/*  displays or retains this license in the documentation and/or other        */
/*  materials provided with the distribution.                                 */
/*                                                                            */
/*  Redistribution and use in source form or binary form, with modification,  */
/*  the whole program or a portion of it, are permitted provided that one     */
/*  declares that it is modified software and not original, and displays or   */
/*  describes any modifications in the documentation and/or other materials   */
/*  provided with the distribution.                                           */
/*                                                                            */
/*  This software and the name of the author must not be used to endorse or   */
/*  promote products derived from this software without prior written         */
/*  permission.                                                               */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/*  EMail   abetakao@bea.hi-ho.ne.jp                                          */
/*          HCA00763@nifty.ne.jp                                              */
/*                                                                            */
/*  URL     http://www.bea.hi-ho.ne.jp/abetakao/                              */
/*                                                                            */
/******************************************************************************/


#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<time.h>
#include	<errno.h>
#include	<sys/types.h>
#include	<sys/time.h>
#include	<sys/ioctl.h>
#include	<sys/socket.h>
#ifdef __sparc
#include	<sys/filio.h>
#endif
#include	<netdb.h>
#include	<netinet/in.h>
#include	<arpa/inet.h>


#include	<X11/Intrinsic.h>


#include	"xmemo.h"
#include	"xmemodata.h"
#include	"xmemofunc.h"


/******************************************************************************/
/*  Application protocol and format : Husen                                   */
/******************************************************************************/

/******************************************************************************/
/*  Local constant definition                                                 */
/******************************************************************************/

#define		XMEMO_HUSEN_TIMEOUT 	5
#define		XMEMO_HUSEN_RETRYOUT	3

/******************************************************************************/
/*  xmemo_TimeoutUdp_Husen                                                    */
/******************************************************************************/

void xmemo_TimeoutUdp_Husen ( zMemberType *pPeer )
{

zMemoType	*pMemo ;

	pMemo = pPeer->pSendMemo ;

	if ( pPeer->iRetry > XMEMO_HUSEN_RETRYOUT ) {

		pMemo->iSendCount -- ;
		if ( pMemo->iSendCount == 0 ) {
			xmemo_RemoveFromChain ( &zSendMemoAnchor, pMemo->pChain ) ;
			xmemo_FreeMemo ( pMemo ) ;
		}

		xmemo_RemoveFromChain ( &zSendPeerAnchor, pPeer->pChain ) ;
		xmemo_FreeMember ( pPeer ) ;

	} else {

		xmemo_NetSend_Husen ( pPeer, pMemo ) ;
	}

	return ;

}

/******************************************************************************/
/*  xmemo_RecvUdp_Husen                                                       */
/******************************************************************************/

void xmemo_RecvUdp_Husen ( zSocketType *pSocket, long iPeerAddr, short iPeerPort, char *data, int datalen )
{

	return ;

}

/******************************************************************************/
/*  xmemo_NetSend_Husen                                                       */
/******************************************************************************/

int xmemo_NetSend_Husen ( zMemberType* pPeer, zMemoType* pMemo )
{

	return RC_ERROR ;

}

/******************************************************************************/
/*  xmemo_NetNotify_Husen                                                     */
/******************************************************************************/

int xmemo_NetNotify_Husen ( int iSock, long iAddr, short iPort, int iNotify )
{

	return RC_ERROR ;

}
